// SDI_SerializeView.cpp : Implementierung der Klasse CSDI_SerializeView
//

#include "stdafx.h"
#include "SDI_Serialize.h"

#include "SDI_SerializeDoc.h"
#include "SDI_SerializeView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSDI_SerializeView

IMPLEMENT_DYNCREATE(CSDI_SerializeView, CFormView)

BEGIN_MESSAGE_MAP(CSDI_SerializeView, CFormView)
	ON_EN_CHANGE(IDC_NAME, &CSDI_SerializeView::OnEnChangeName)
	ON_EN_CHANGE(IDC_MATRNR, &CSDI_SerializeView::OnEnChangeMatrnr)
	ON_LBN_SELCHANGE(IDC_PRUEFUNG, &CSDI_SerializeView::OnLbnSelchangePruefung)
END_MESSAGE_MAP()

// CSDI_SerializeView-Erstellung/Zerstrung

CSDI_SerializeView::CSDI_SerializeView()
	: CFormView(CSDI_SerializeView::IDD)
	, m_name(_T(""))
	, m_matrnr(0)
{
	// TODO: Hier Code zur Konstruktion einfgen
	m_start=true;

}

CSDI_SerializeView::~CSDI_SerializeView()
{
}

void CSDI_SerializeView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_NAME, m_name);
	DDX_Text(pDX, IDC_MATRNR, m_matrnr);
	DDX_Control(pDX, IDC_PRUEFUNG, m_pruefung_ctrl);
	DDX_Control(pDX, IDC_SPIN1, m_matrnr_spin_ctrl);
}

BOOL CSDI_SerializeView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ndern Sie hier die Fensterklasse oder die Darstellung, indem Sie
	//  CREATESTRUCT cs modifizieren.

	return CFormView::PreCreateWindow(cs);
}

void CSDI_SerializeView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();
	m_pruefung_ctrl.ResetContent();
	m_pruefung_ctrl.AddString("Grundlagen der Informatik 1");
	m_pruefung_ctrl.AddString("Grundlagen der Informatik 2");
	m_pruefung_ctrl.AddString("Betriebssysteme");
	m_pruefung_ctrl.AddString("Grafische Nutzerschnittstellen");
	m_pruefung_ctrl.AddString("Parallele Algorithmen");

	// AfxMessageBox("onintaialUpdate");

	m_matrnr_spin_ctrl.SetRange(1,31999);

	CSDI_SerializeDoc* pDoc = GetDocument();
	CString sName;
	unsigned int matrnr;
	int index;
	sName = pDoc->getName();
	matrnr = pDoc->getMatrnr();
	index = pDoc->getPruefungslistenIndex();

	m_name = sName;
	m_matrnr = matrnr;
	UpdateData(false);
	m_pruefung_ctrl.SetCurSel(index);	
	UpdateData(false);

	m_start=false;
}


// CSDI_SerializeView-Diagnose

#ifdef _DEBUG
void CSDI_SerializeView::AssertValid() const
{
	CFormView::AssertValid();
}

void CSDI_SerializeView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CSDI_SerializeDoc* CSDI_SerializeView::GetDocument() const // Nicht-Debugversion ist inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSDI_SerializeDoc)));
	return (CSDI_SerializeDoc*)m_pDocument;
}
#endif //_DEBUG



void CSDI_SerializeView::OnDraw(CDC* pDC ) {
	CSDI_SerializeDoc* pDoc = GetDocument();
	CString sName;
	int matrnr;
	int index;
	sName = pDoc->getName();
	matrnr = pDoc->getMatrnr();
	index = pDoc->getPruefungslistenIndex();

	m_name = sName;
	m_matrnr = matrnr;
	UpdateData(false);
	m_pruefung_ctrl.SetCurSel(index);	
	UpdateData(false);
}

// CSDI_SerializeView-Meldungshandler

void CSDI_SerializeView::OnEnChangeName(){
	CSDI_SerializeDoc* pDoc = GetDocument();
	CString sName;
	if (!m_start) {
		UpdateData(true);
		sName = m_name;
		pDoc->setName(sName);
		//Invalidate();  // okay 
		//pDoc->UpdateAllViews(NULL);
		pDoc->SetModifiedFlag(true);
	}
}

void CSDI_SerializeView::OnEnChangeMatrnr(){
	CSDI_SerializeDoc* pDoc = GetDocument();
	unsigned int matrnr;
	if (!m_start) {
		UpdateData(true);
		matrnr = m_matrnr;
		pDoc->setMatrnr(matrnr);
		//Invalidate();  // okay 
		//pDoc->UpdateAllViews(NULL);
		pDoc->SetModifiedFlag(true);
	}
}

void CSDI_SerializeView::OnLbnSelchangePruefung(){
	CSDI_SerializeDoc* pDoc = GetDocument();
	int index;
	CString sStr;
	if (!m_start) {
		UpdateData(true);		
		index=m_pruefung_ctrl.GetCurSel();
		pDoc->setPruefungslistenIndex(index);
		//Invalidate();  // okay 
		// pDoc->UpdateAllViews(NULL);
		pDoc->SetModifiedFlag(true);
	}
}

